searchNodes=[{"doc":"","ref":"Mix.Tasks.Compile.Temple.html","title":"Mix.Tasks.Compile.Temple","type":"task"},{"doc":"Temple syntax is available inside the temple , and is compiled into efficient Elixir code at compile time using the configured EEx.Engine . You should checkout the guides for a more in depth explanation. Usage defmodule MyApp.HomePage do import Temple def render ( ) do assigns = %{ title : &quot;My Site | Sign Up&quot; , logged_in : false } temple do &quot;&lt;!DOCTYPE html&gt;&quot; html do head do meta charset : &quot;utf-8&quot; meta http_equiv : &quot;X-UA-Compatible&quot; , content : &quot;IE=edge&quot; meta name : &quot;viewport&quot; , content : &quot;width=device-width, initial-scale=1.0&quot; link rel : &quot;stylesheet&quot; , href : &quot;/css/app.css&quot; title do : @title end body do header class : &quot;header&quot; do ul do li do a href : &quot;/&quot; , do : &quot;Home&quot; end li do if @logged_in do a href : &quot;/logout&quot; , do : &quot;Logout&quot; else a href : &quot;/login&quot; , do : &quot;Login&quot; end end end end main do &quot;Hi! Welcome to my website.&quot; end end end end end end Configuration Engine By default Temple wil use the EEx.SmartEngine , but you can configure it to use any other engine. Examples could be Phoenix.HTML.Engine or Phoenix.LiveView.Engine . config :temple , engine : Phoenix.HTML.Engine Aliases You can add an alias for an element if there is a namespace collision with a function. If you are using Phoenix.HTML , there will be namespace collisions with the &lt;link&gt; and &lt;label&gt; elements. config :temple , :aliases , label : :label_tag , link : :link_tag , select : :select_tag temple do label_tag do &quot;Email&quot; end link_tag href : &quot;/css/site.css&quot; end This will result in: &lt;label&gt; Email &lt;/label&gt; &lt;link href=&quot;/css/site.css&quot;&gt;","ref":"Temple.html","title":"Temple","type":"module"},{"doc":"","ref":"Temple.html#temple/1","title":"Temple.temple/1","type":"macro"},{"doc":"You are looking at the README for the main branch. The README for the latest stable release is located here . Temple is an Elixir DSL for writing HTML.","ref":"readme.html","title":"","type":"extras"},{"doc":"Add temple to your list of dependencies in mix.exs : def deps do [ { :temple , &quot;~&gt; 0.9.0-rc.0&quot; } ] end","ref":"readme.html#installation","title":" - Installation","type":"extras"},{"doc":"Currently Temple has the following things on which it won't compromise. Will only work with valid Elixir syntax. Should work in all web environments such as Plug, Aino, Phoenix, and Phoenix LiveView.","ref":"readme.html#goals","title":" - Goals","type":"extras"},{"doc":"Using Temple is as simple as using the DSL inside of an temple/1 block. The runtime result of the macro is your HTML. See the guides for more details. import Temple temple do h2 do : &quot;todos&quot; ul class : &quot;list&quot; do for item &lt;- @items do li class : &quot;item&quot; do div class : &quot;checkbox&quot; do div class : &quot;bullet hidden&quot; end div do : item end end end script do : &quot;&quot;&quot; function toggleCheck({currentTarget}) { currentTarget.children[0].children[0].classList.toggle(&quot;hidden&quot;); } let items = document.querySelectorAll(&quot;li&quot;); Array.from(items).forEach(checkbox =&gt; checkbox.addEventListener(&quot;click&quot;, toggleCheck)); &quot;&quot;&quot; end Components Temple components are simple to write and easy to use. Unlike normal partials, Temple components have the concept of &quot;slots&quot;, which are similar Vue . You can also refer to HEEx and Surface for examples of templates that have the &quot;slot&quot; concept. Please see the guides for more details. defmodule MyAppWeb.Component do import Temple def card ( assigns ) do temple do section do div do slot :header end div do slot :default end div do slot :footer end end end end end Using components is as simple as passing a reference to your component function to the c keyword. import MyAppWeb.Component c &amp; card / 1 do slot :header do @user . full_name end @user . bio slot :footer do a href : &quot;https://twitter.com/ \#{ @user . twitter } &quot; do &quot;@ \#{ @user . twitter } &quot; end a href : &quot;https://github.com/ \#{ @user . github } &quot; do &quot;@ \#{ @user . github } &quot; end end end Engine By default, Temple will use the EEx.SmartEngine that is built into the Elixir standard library. If you are a web framework that uses it's own template engine (such as Aino and Phoenix/LiveView, you can configure Temple to it! # config/config.exs config :temple , engine : Aino.View.Engine # or Phoenix.HTML.Engine or Phoenix.LiveView.Engine Formatter To include Temple's formatter configuration, add :temple to your .formatter.exs . [ import_deps : [ :temple ] , inputs : [ &quot;*.{ex,exs}&quot; , &quot;priv/*/seeds.exs&quot; , &quot;{config,lib,test}/**/*.{ex,exs,lexs}&quot; ] , ]","ref":"readme.html#usage","title":" - Usage","type":"extras"},{"doc":"To use with Phoenix , please use the temple_phoenix package! This bundles up some useful helpers as well as the Phoenix Template engine.","ref":"readme.html#phoenix","title":" - Phoenix","type":"extras"},{"doc":"Introducing Temple: An elegant HTML library for Elixir and Phoenix Temple, AST, and Protocols Thinking Elixir Episode 92: Temple with Mitchell Hanberg How EEx Turns Your Template Into HTML","ref":"readme.html#related","title":" - Related","type":"extras"},{"doc":"","ref":"getting-started.html","title":"Getting Started","type":"extras"},{"doc":"Welcome! Temple is a HTML DSL for Elixir, let's get started! First, make sure you are using Elixir V1.13 or higher. Add :temple to your deps and run mix deps.get { :temple , &quot;~&gt; 0.9.0-rc.0&quot; } Now you must prepend the Temple compiler to your projects :compilers configuration in mix.exs . There is a chance that your project doesn't set this option at all, but don't worry, it's really easy to add! defmodule MyApp.MixProject do use Mix.Project def project do [ # ... compilers : [ :temple ] ++ Mix . compilers ( ) , # ... ] end # ... end All done, Now let's start building our app!","ref":"getting-started.html#install","title":"Getting Started - Install","type":"extras"},{"doc":"Temple works out of the box without any configuration, but here are a couple of conifg options that you could need to use. Engine By default, Temple uses the built in EEx.SmartEngine . If you want to use a different engine, this is as easy as setting the :engine configuration option. # config/config.exs config :temple , engine : Phoenix.HTML.Engine Aliases Temple code will reserve some local function calls for HTML tags. If you have a local function that you would like to use instead, you can create an alias for any tag. Common aliases for Phoenix projects look like this: config :temple , aliases : [ label : :label_tag , link : :link_tag , select : :select_tag , textarea : :textarea_tag ]","ref":"getting-started.html#configuration","title":"Getting Started - Configuration","type":"extras"},{"doc":"A Temple template is written inside of the Temple.temple/1 macro. Code inside there will be compiled into efficient Elixir code by the configured EEx engine. Local functions that have a corresponding HTML5 tag are reserved and will be used when generated your markup. Let's take a look at a basic form written with Temple. defmodule MyApp.FormExample do import Temple def form_page ( ) do assigns = %{ title : &quot;My Site | Sign Up&quot; , logged_in : false } temple do &quot;&lt;!DOCTYPE html&gt;&quot; html do head do meta charset : &quot;utf-8&quot; meta http_equiv : &quot;X-UA-Compatible&quot; , content : &quot;IE=edge&quot; meta name : &quot;viewport&quot; , content : &quot;width=device-width, initial-scale=1.0&quot; link rel : &quot;stylesheet&quot; , href : &quot;/css/app.css&quot; title do : @title end body do if @logged_in do header class : &quot;header&quot; do ul do li do a href : &quot;/&quot; , do : &quot;Home&quot; end li do a href : &quot;/logout&quot; , do : &quot;Logout&quot; end end end end form action : &quot;&quot; , method : &quot;get&quot; , class : &quot;form-example&quot; do div class : &quot;form-example&quot; do label for : &quot;name&quot; , do : &quot;Enter your name:&quot; input type : &quot;text&quot; , name : &quot;name&quot; , id : &quot;name&quot; , required : true end div class : &quot;form-example&quot; do label for : &quot;email&quot; , do : &quot;Enter your email:&quot; input type : &quot;email&quot; , name : &quot;email&quot; , id : &quot;email&quot; , required : true end div class : &quot;form-example&quot; do input type : &quot;submit&quot; , value : &quot;Subscribe!&quot; end end end end end end end This example showcases an entire HTML page made with Temple! Let's dive a little deeper everything we're seeing here. Through out this guide, you will see code that includes features that are explained later on. Feel free to skip ahead to read on, or just keep reading. It will all make sense eventually!","ref":"your-first-template.html","title":"Your First Template","type":"extras"},{"doc":"The text node is a basic building block of any HTML document. In Temple, text nodes are represented by Elixir string literals. The very first line of the previous example is our doc type, emitted into the final document with &quot;&lt;!DOCTYPE html&gt;&quot; . This is a text node and will be emitted into the document as-is. Note: String literals are emitted into text nodes. If you are using string interpolation with the \#{some_expression} syntax, that is treated as an expression and will be evaluated in whichever way the configured engine evaluates expression. By default, the EEx.SmartEngine doesn't do any escaping of expressions, so that could still be emitted as-is, or even as HTML to be interpreted by your web browser.","ref":"your-first-template.html#text-nodes","title":"Your First Template - Text Nodes","type":"extras"},{"doc":"Void tags are HTML5 tags that do not have children, meaning they are &quot;self closing&quot;. We can observe these in the previous example as the &lt;input&gt; tag. You'll note that the tag does not have a :do key or a do block.","ref":"your-first-template.html#void-tags","title":"Your First Template - Void Tags","type":"extras"},{"doc":"Non-void tags are HTML5 tags that do have children. You are probably most familiar with these type of tags, as they include the famous &lt;div&gt;&lt;/div&gt; and &lt;span&gt;&lt;/span&gt; . These tags can enclose their children nodes with either a do/end block or the inline :do keyword. Whitespace Nonvoid tags that use the do/end syntax will be emitted with internal whitespace. temple do div class : &quot;foo&quot; do # children end end ...will emit markup that looks like... &lt;div class=&quot;foo&quot;&gt; &lt;!-- children --&gt; &lt;/div&gt; Note: The Elixir comment will not be rendered into an HTML comment. This is just used in the example. (This does sound like a good feature though...) Nonvoid tags that use the :do keyword syntax will be emitted without internal whitespace. This allows you to correctly use the :empty CSS psuedo-selector in your stylesheet. temple do p class : &quot;alert alert-info&quot; , do : &quot;Your account was recently updated!&quot; end ...will emit markup that looks like... &lt;p class=&quot;alert alert-info&quot;&gt;Your account was recently updated!&lt;/p&gt;","ref":"your-first-template.html#non-void-tags","title":"Your First Template - Non-void Tags","type":"extras"},{"doc":"Attributes are declared as a keyword list. Keys with underscores are converted to the kebab syntax. Values can be Elixir expressions. Values that are compile time true will be emitted as a boolean attribute. disabled and checked are examples of boolean attributes. Values that are compile time false will not be emitted into the document at all. The class attribute has a special &quot;object syntax&quot; that allows you to specify classes as a keyword list, only emitting classes that evaluate to true into the final class. Let's look at an example. assigns = %{ highlight? : false , user_name : &quot;Mitch&quot; } temple do div id : &quot;hero&quot; do h2 class : &quot;font-bold&quot; , do : &quot;Profile&quot; section data_controller : &quot;hero&quot; do p class : [ &quot;border&quot; : @highlight? ] do &quot;Name: \#{ @user_name } &quot; end video autoplay : true , src : &quot;https://example.com/rick-rolled.mp4&quot; end end end ...will emit markup that looks like... &lt;div id=&quot;hero&quot;&gt; &lt;h2 class=&quot;font-bold&quot;&gt;Profile&lt;/h2&gt; &lt;section data-controller=&quot;hero&quot;&gt; &lt;p class=&quot;&quot;&gt; Name: Mitch &lt;/p&gt; &lt;/section&gt; &lt;video autoplay src=&quot;https://example.com/rick-rolled.mp4&quot;&gt;&lt;/video&gt; &lt;/div&gt;","ref":"your-first-template.html#attributes","title":"Your First Template - Attributes","type":"extras"},{"doc":"They Just Work Any Elixir expression can be used anywhere inside of a Temple template. Here are a few examples. temple do h2 do : &quot;Members&quot; ul do for member &lt;- @members do li do : member end end end Match Expressions Match expression are handled slightly differently. Generally if you are assigning an expression to a variable (a match), you are going to use that binding later and do not want to emit it into the document. So, match expressions are not emitted into the document. They are functionally equivalent to the &lt;% .. %. syntax of EEx . The expression is evaluated, but not included in the rendered document. Typically you should not be writing this type of expression inside of your template, but if you wanted to declare an alias, you would need to write the following to not emit the alias into the document. temple do _ = alias My.Deep.Module div do Module . func ( ) end end","ref":"your-first-template.html#elixir-expressions","title":"Your First Template - Elixir Expressions","type":"extras"},{"doc":"Since Temple uses the EEx.SmartEngine by default, you are able to use the assigns feature. The assigns feature allows you to ergonomically access the members of a assigns variable by the @ macro. The assign variable just needs to exist within the scope of the template (the same as a normal EEx template that uses EEx.SmartEngine ), it can be a function parameter or created inside the function. def card ( assigns ) do temple do div class : &quot;card&quot; do section class : &quot;card-header&quot; do @name end section class : &quot;card-body&quot; do @bio end if Enum . any? ( @socials ) do section class : &quot;card-footer&quot; do for social &lt;- @socials do a href : social . link do social . name end end end end end end end","ref":"your-first-template.html#assigns","title":"Your First Template - Assigns","type":"extras"},{"doc":"Temple has the concept of components, which allow you an expressive and composable way to break up your templates into re-usable chunks. A component is any arity-1 function that take an argument called assigns and returns the result of the Temple.temple/1 macro.","ref":"components.html","title":"Components","type":"extras"},{"doc":"Here is an example of a simple Temple component. You can observe that it seems very similar to a regular Temple template, and that is because it is a regular template! defmodule MyApp.Components do import Temple def button ( assigns ) do temple do button type : &quot;button&quot; , class : &quot;bg-blue-800 text-white rounded \#{ @class } &quot; do @text end end end end","ref":"components.html#definition","title":"Components - Definition","type":"extras"},{"doc":"To use a component, you will use the special c keyword. This is called a &quot;keyword&quot; because it is not a function or macro, but only exists inside of the Temple.temple/1 block. The first argument will be the function reference to your component function, followed by any assigns. defmodule MyApp.ConfirmDialog do import Temple import MyApp.Components def render ( assigns ) do temple do dialog open : true do p do : &quot;Are you sure?&quot; form method : &quot;dialog&quot; do c &amp; button / 1 , class : &quot;border border-white&quot; , text : &quot;Yes&quot; end end end end end","ref":"components.html#usage","title":"Components - Usage","type":"extras"},{"doc":"Temple components can take &quot;slots&quot; as well. This is the method for providing dynamic content from the call site into the component. Slots are defined and rendered using the slot keyword. This is similar to the c keyword, in that it is not defined using a function or macro. Default Slot The default slot can be rendered from within your component by passing the slot the atom :default . Let's redefine our button component using slots. defmodule MyApp.Components do import Temple def button ( assigns ) do temple do button type : &quot;button&quot; , class : &quot;bg-blue-800 text-white rounded \#{ @class } &quot; do slot :default end end end end You can pass content through the &quot;default&quot; slot of your component simply by passing a do/end block to your component at the call site. This is a special case for the default slot. defmodule MyApp.ConfirmDialog do import Temple import MyApp.Components def render ( assigns ) do temple do dialog open : true do p do : &quot;Are you sure?&quot; form method : &quot;dialog&quot; do c &amp; button / 1 , class : &quot;border border-white&quot; do &quot;Yes&quot; end end end end end end Named Slots You can also define a &quot;named&quot; slot, which allows you to pass more than one set of dynamic content to your component. We'll use a &quot;card&quot; example to illustrate this. This example is adapted from the Surface documentation on slots. Definition defmodule MyApp.Components do import Temple def card ( assigns ) do temple do div class : &quot;card&quot; do header class : &quot;card-header&quot; , style : &quot;background-color: @f5f5f5&quot; do p class : &quot;card-header-title&quot; do slot :header end end div class : &quot;card-content&quot; do div class : &quot;content&quot; do slot :default end end footer class : &quot;card-footer&quot; , style : &quot;background-color: #f5f5f5&quot; do slot :footer end end end end end Usage def MyApp.CardExample do import Temple import MyApp.Components def render ( assigns ) do temple do c &amp; card / 1 do slot :header do &quot;A simple card component&quot; end &quot;This example demonstrates how to create components with multiple, named slots&quot; slot :footer do a href = &quot;#&quot; , class : &quot;card-footer-item&quot; , do : &quot;Footer Item 1&quot; a href = &quot;#&quot; , class : &quot;card-footer-item&quot; , do : &quot;Footer Item 2&quot; end end end end end","ref":"components.html#slots","title":"Components - Slots","type":"extras"},{"doc":"Sometimes it is necessary to pass data from a component definition back to the call site. Let's look at what a table component could look like. Definition defmodule MyApp.Components do import Temple def cols ( items ) do items |&gt; List . first ( ) |&gt; Map . keys ( ) |&gt; Enum . sort ( ) end def table ( assigns ) do temple do table do thead do tr do for col &lt;- cols ( @entries ) do tr do : String . upcase ( to_string ( col ) ) end end end tbody do for row &lt;- @entries do tr do for col &lt;- cols ( @entries ) do td do slot :cell , %{ value : row [ cell ] } end end end end end end end end end Usage When we render the slot, we can pattern match on the data passed through the slot. If this seems familiar, it's because this is the same syntax you use when writing your tests using ExUnit.Case.test/3 . def MyApp.TableExample do import Temple import MyApp.Componens def render ( assigns ) do temple do section do h2 do : &quot;Inventory Levels&quot; c &amp; table / 1 , entries : @item_inventories do slot :cell , %{ value : value } do case value do 0 -&gt; span class : &quot;font-bold&quot; do &quot;Out of stock!&quot; end level when is_number ( level ) -&gt; span do &quot; \#{ level } in stock&quot; end _ -&gt; span do : value end end end end end end end","ref":"components.html#passing-data-through-slots","title":"Components - Passing Data Through Slots","type":"extras"},{"doc":"First off, Temple now requires Elixir 1.13 or higher. This is because of some changes that were brought to the Elixir parser.","ref":"0-8-to-0-9.html","title":"Migrating from 0.8 to 0.9","type":"extras"},{"doc":"To control whitespace in an element, Temple will now control this based on whether the do was used in the keyword list syntax or the do/end syntax. In 0.8, you would do: span do &quot;hello!&quot; end # &lt;span&gt; # hello! # &lt;/span&gt; # The ! version of the element would render it as &quot;tight&quot; span! do &quot;hello!&quot; end # &lt;span&gt;hello!&lt;/span&gt; In 0.9, you would do: span do &quot;hello!&quot; end # &lt;span&gt; # hello! # &lt;/span&gt; span do : &quot;hello!&quot; # &lt;span&gt;hello!&lt;/span&gt;","ref":"0-8-to-0-9.html#whitespace-control","title":"Migrating from 0.8 to 0.9 - Whitespace Control","type":"extras"},{"doc":"Components are no longer module based. To render a component, you can pass a function reference to the c keyword. You also no longer need to define a component in a module, using the Temple.Component module and its render macro. In 0.8, you would define a component like: defmodule MyAppWeb.Component.Card do import Temple.Component render do div class : &quot;border p-4 rounded&quot; do slot :default end end end And you would use the component like: div do c MyAppWeb.Component.Card do &quot;Welcome to my app!&quot; end end In 0.9, you would define a component like: defmodule MyAppWeb.Components do import Temple def card ( assigns ) do temple do div class : &quot;border p-4 rounded&quot; do slot :default end end end end And you would use the component like: div do c &amp; MyAppWeb.Components . card / 1 do &quot;Welcome to my app!&quot; end end We can observe here that in 0.9 the component is just any 1-arity function, so you can define them anywhere and you can have more than 1 in a single module. defcomp Now that components are just functions, you no longer need this special macro to define a component in the middle of the module. This can simply be converted to a function.","ref":"0-8-to-0-9.html#components","title":"Migrating from 0.8 to 0.9 - Components","type":"extras"},{"doc":"All Phoenix related items have moved to the temple_phoenix package. Please see that library docs for more details.","ref":"0-8-to-0-9.html#phoenix","title":"Migrating from 0.8 to 0.9 - Phoenix","type":"extras"}]